
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Material_issue_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const material_issue_lines = await db.material_issue_lines.create(
            {
                id: data.id || undefined,
        
        quantity: data.quantity
        ||
        null
            ,
            
        line_status: data.line_status
        ||
        null
            ,
            
        line_notes: data.line_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await material_issue_lines.setMaterial_issue( data.material_issue || null, {
            transaction,
        });
        
        await material_issue_lines.setComponent_item( data.component_item || null, {
            transaction,
        });
        
        await material_issue_lines.setLot( data.lot || null, {
            transaction,
        });
        
        await material_issue_lines.setFrom_location( data.from_location || null, {
            transaction,
        });
        
        await material_issue_lines.setUom( data.uom || null, {
            transaction,
        });
        

        

        

        return material_issue_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const material_issue_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity: item.quantity
            ||
            null
            ,
            
                line_status: item.line_status
            ||
            null
            ,
            
                line_notes: item.line_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const material_issue_lines = await db.material_issue_lines.bulkCreate(material_issue_linesData, { transaction });

        // For each item created, replace relation files
        

        return material_issue_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const material_issue_lines = await db.material_issue_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.line_status !== undefined) updatePayload.line_status = data.line_status;
        
        
        if (data.line_notes !== undefined) updatePayload.line_notes = data.line_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await material_issue_lines.update(updatePayload, {transaction});

        
        
        if (data.material_issue !== undefined) {
            await material_issue_lines.setMaterial_issue(
              
              data.material_issue,
              
              { transaction }
            );
        }
        
        if (data.component_item !== undefined) {
            await material_issue_lines.setComponent_item(
              
              data.component_item,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await material_issue_lines.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.from_location !== undefined) {
            await material_issue_lines.setFrom_location(
              
              data.from_location,
              
              { transaction }
            );
        }
        
        if (data.uom !== undefined) {
            await material_issue_lines.setUom(
              
              data.uom,
              
              { transaction }
            );
        }
        

        
        

        

        return material_issue_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const material_issue_lines = await db.material_issue_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of material_issue_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of material_issue_lines) {
                await record.destroy({transaction});
            }
        });


        return material_issue_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const material_issue_lines = await db.material_issue_lines.findByPk(id, options);

        await material_issue_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await material_issue_lines.destroy({
            transaction
        });

        return material_issue_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const material_issue_lines = await db.material_issue_lines.findOne(
            { where },
            { transaction },
        );

        if (!material_issue_lines) {
            return material_issue_lines;
        }

        const output = material_issue_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.material_issue = await material_issue_lines.getMaterial_issue({
            transaction
        });
        
        
        output.component_item = await material_issue_lines.getComponent_item({
            transaction
        });
        
        
        output.lot = await material_issue_lines.getLot({
            transaction
        });
        
        
        output.from_location = await material_issue_lines.getFrom_location({
            transaction
        });
        
        
        output.uom = await material_issue_lines.getUom({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.material_issues,
        as: 'material_issue',
        
        where: filter.material_issue ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material_issue.split('|').map(term => Utils.uuid(term)) } },
            {
              issue_number: {
                [Op.or]: filter.material_issue.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.items,
        as: 'component_item',
        
        where: filter.component_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.component_item.split('|').map(term => Utils.uuid(term)) } },
            {
              item_name: {
                [Op.or]: filter.component_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_code: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'from_location',
        
        where: filter.from_location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.from_location.split('|').map(term => Utils.uuid(term)) } },
            {
              location_name: {
                [Op.or]: filter.from_location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.uoms,
        as: 'uom',
        
        where: filter.uom ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uom.split('|').map(term => Utils.uuid(term)) } },
            {
              uom_name: {
                [Op.or]: filter.uom.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.line_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'material_issue_lines',
                        'line_notes',
                        filter.line_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.line_status) {
                where = {
                    ...where,
                line_status: filter.line_status,
            };
            }
            


      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.material_issue_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'material_issue_lines',
                        'line_notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.material_issue_lines.findAll({
            attributes: [ 'id', 'line_notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['line_notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.line_notes,
        }));
    }

    
};

